"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
function createSave(storage) {
    return function (key, state) { return state ? storage.set(key, JSON.stringify(state)) : storage.remove(key); };
}
function createLoad(storage) {
    return function (key) {
        var data = storage.get(key);
        return data ? JSON.parse(data) : null;
    };
}
function keep(options) {
    var key = options.key, selector = options.selector;
    return {
        key: key,
        selector: selector,
        save: options.save || createSave(options.storage),
        load: options.load || createLoad(options.storage)
    };
}
exports.keep = keep;
exports.HYDRATE = 'keep/HYDRATE';
function default_1() {
    var keeps = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        keeps[_i] = arguments[_i];
    }
    return function (store) {
        var payload = keeps.reduce(function (action, _a) {
            var key = _a.key, load = _a.load;
            return (__assign({}, action, (_b = {}, _b[key] = load(key), _b)));
            var _b;
        }, {});
        store.dispatch({
            payload: payload,
            type: exports.HYDRATE
        });
        store.subscribe(function () {
            var state = store.getState();
            for (var _i = 0, keeps_1 = keeps; _i < keeps_1.length; _i++) {
                var _a = keeps_1[_i], key = _a.key, selector = _a.selector, save = _a.save;
                save(key, selector(state));
            }
        });
    };
}
exports.default = default_1;
